// *****************************************************************
//
// Name:        IObject.java
//
// Description: Base class for IVector element.
//
//
// Author:      Victor Chan
// *****************************************************************
//
// copyright:    Licensed Materials - Property of IBM
//
//               xxx-yyy (C) Copyright IBM Corporation 1995.
//               All rights reserved.
//               US Government Users Restricted Rights - Use,
//               duplication or disclosure restricted by GSA ADP
//               Schedule Contract with IBM Corp.
//
//               See Copyright Instructions, G120-2083.
// ****************************************************************
//
// notice:       OCO Source Materials
//
//               This module contains IBM Confidential code.
// ****************************************************************

/*******************************************************************************

*******************************************************************************/

package COM.ibm.ivj.javabeans;

import java.beans.*;
import java.util.*;


public class IObject implements IObjectInterface {
    private static String copywrite = "IBM(R) VisualAge(TM) for Java(TM), Version 1 and others\n - Licensed Material - Program-Property of IBM\n(C) Copyright IBM Corp. 1997 - All Rights Reserved.\nUS Government Users Restricted Rights - Use, duplication or disclosure\nrestricted by GSA ADP Schedule Contract with IBM Corp.";

    public void addPropertyChangeListener (PropertyChangeListener listener) {
        listeners.addPropertyChangeListener (listener);
    }

    public void removePropertyChangeListener (PropertyChangeListener listener){
        listeners.removePropertyChangeListener (listener);
    }

    public void firePropertyChange (String pname, Object oldValue,
                                         Object newValue) {
        listeners.firePropertyChange (pname, oldValue, newValue);
    }

    private PropertyChangeSupport listeners = new PropertyChangeSupport (this);
}

