package COM.ibm.ivj.javabeans;

// *****************************************************************
//
// Name:        IObjectInterface.java
//
// Description: Base class interface for IVector element. The IVector
//              element raises property change event when its content is
//              changed
//
//
// Author:      Victor Chan
// *****************************************************************
//
// copyright:    Licensed Materials - Property of IBM
//
//               xxx-yyy (C) Copyright IBM Corporation 1995.
//               All rights reserved.
//               US Government Users Restricted Rights - Use,
//               duplication or disclosure restricted by GSA ADP
//               Schedule Contract with IBM Corp.
//
//               See Copyright Instructions, G120-2083.
// ****************************************************************
//
// notice:       OCO Source Materials
//
//               This module contains IBM Confidential code.
// ****************************************************************


import java.beans.*;
import java.util.*;


public interface IObjectInterface extends java.io.Serializable {
    static final String copywrite = "IBM(R) VisualAge(TM) for Java(TM), Version 1 and others\n - Licensed Material - Program-Property of IBM\n(C) Copyright IBM Corp. 1997 - All Rights Reserved.\nUS Government Users Restricted Rights - Use, duplication or disclosure\nrestricted by GSA ADP Schedule Contract with IBM Corp.";

    public void addPropertyChangeListener (PropertyChangeListener listener);

    public void removePropertyChangeListener (PropertyChangeListener listener);

    public void firePropertyChange (String pname, Object oldValue,
                                         Object newValue);
}

